'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Spacecrypt = function () {
  function Spacecrypt() {
    _classCallCheck(this, Spacecrypt);
  }

  _createClass(Spacecrypt, [{
    key: 'str2bin',
    value: function str2bin(text) {
      var bin = [];
      text.split('').map(function (char) {
        !!char && bin.push(Number(char.charCodeAt(0)).toString(2));
        return;
      });
      return bin.join(' ');
    }
  }, {
    key: 'bin2str',
    value: function bin2str(bin) {
      var text = [];
      bin.split(' ').map(function (char) {
        !!char && text.push(String.fromCharCode(parseInt(char, 2)));
        return;
      });
      return text.join('');
    }
  }, {
    key: 'bin2hidden',
    value: function bin2hidden(str) {
      str = str.replace(/ /g, '\u2060'); // Unicode Character 'WORD JOINER' (U+2060) 0xE2 0x81 0xA0
      str = str.replace(/0/g, '\u200B'); // Unicode Character 'ZERO WIDTH SPACE' (U+200B) 0xE2 0x80 0x8B
      str = str.replace(/1/g, '\u200C'); // Unicode Character 'ZERO WIDTH NON-JOINER' (U+200C) 0xE2 0x80 0x8C
      return str;
    }
  }, {
    key: 'hidden2bin',
    value: function hidden2bin(str) {
      str = str.replace(/[^\u2060\u200B\u200C]/g, ''); // Strip all but hidden characters
      str = str.replace(/\u2060/g, ' '); // Unicode Character 'WORD JOINER' (U+2060) 0xE2 0x81 0xA0
      str = str.replace(/\u200B/g, '0'); // Unicode Character 'ZERO WIDTH SPACE' (U+200B) 0xE2 0x80 0x8B
      str = str.replace(/\u200C/g, '1'); // Unicode Character 'ZERO WIDTH NON-JOINER' (U+200C) 0xE2 0x80
      return str;
    }
  }, {
    key: 'encrypt',
    value: function encrypt(pub, priv) {
      var privBin = this.str2bin(priv);
      // console.log(privBin, '\n');

      var privHidden = this.bin2hidden(privBin);
      // console.log(privHidden, '\n');

      // const encoded = pub.replace(' ', privHidden + ' ');
      // Insert hidden message after the second character
      var encoded = '' + pub.slice(0, 1) + privHidden + pub.slice(1);
      // console.log(encoded, '\n');
      return encoded;
    }
  }, {
    key: 'decrypt',
    value: function decrypt(text) {
      var decodedBin = this.hidden2bin(text);
      // console.log(decodedBin.length);

      var decodedStr = this.bin2str(decodedBin);
      // console.log(decodedStr, '\n');
      return decodedStr;
    }
  }]);

  return Spacecrypt;
}();

exports.default = new Spacecrypt();